/*
Daybo Logic C RTL Memory Manager
Copyright (c) 2000-2006, David Duncan Ross Palmer, Daybo Logic
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
      
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
      
    * Neither the name of the Daybo Logic nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/
#ifndef INC_DPCRTLMM_INTDATA_H
#define INC_DPCRTLMM_INTDATA_H
/*-------------------------------------------------------------------------*/
/* WARNING! This header is for internal library use only, it contains
internal data for the library. */

#include "build.h" /* Build parameters */

/* Internal library data */
extern PS_DPCRTLMM_BLOCKDESCARRAY dpcrtlmm_int__safetyList[DPCRTLMM_SAFETYLIST_MAXSIZE]; /* List of pointers to arrays of block descriptors (for validating array base pointers) */
#ifndef DPCRTLMM_NONULL_BLOCKDESCARRAY /* New NULL block array support enabled? */
  extern S_DPCRTLMM_BLOCKDESCARRAY dpcrtlmm_int__defaultArray; /* Always here, never created, never destroyed accessable by specifying NULL for an array pointer */
#endif /*!DPCRTLMM_NONULL_BLOCKDESCARRAY*/
extern unsigned int dpcrtlmm_int__libStarted; /* Set TRUE when library is started */
extern void (*dpcrtlmm_int__UserTrapCallback)(const unsigned int Id, const char* Message); /* The user trap handle must not be called by us unless is is a valid pointer */
extern unsigned int dpcrtlmm_int__userTrapCallbackIsHook; /* Indication as to the manner in which the user trap callback expects to be treated, as a hook or as a handler */
#ifdef DPCRTLMM_DEBUGHOOKS
extern unsigned int (*dpcrtlmm_int__debugHookMatrix[DPCRTLMM_HOOKCHAIN_SIZE][DPCRTLMM_DEBUGHOOK_LASTHOOK+1])(PS_DPCRTLMM_DEBUGHOOKINFO PDebugHookInfo); /* Debug hook matrix (sizeof(a hook) * hook types * maximum hook chain length) */
#endif /*DPCRTLMM_DEBUGHOOKS*/
#ifdef DPCRTLMM_NONULL_BLOCKDESCARRAY
# define dpcrtlmm_int__ResolveArrayPtr(p) (p)  /* Resolving not neccersary, it's for the NULL array */
#else
# define dpcrtlmm_int__ResolveArrayPtr(p) ((p) ? (p) : (&dpcrtlmm_int__defaultArray))
#endif /*DPCRTLMM_NONULL_BLOCKDESCARRAY*/
/* Statistics */
extern unsigned long dpcrtlmm_int__blockCount;
extern unsigned long dpcrtlmm_int__blockCountPeak;
extern unsigned long dpcrtlmm_int__allocCharge;
extern unsigned long dpcrtlmm_int__allocPeak;

/* Magic lazy references for library's own use */
#define _safetyList dpcrtlmm_int__safetyList
#ifndef DPCRTLMM_NONULL_BLOCKDESCARRAY
#  define _defaultArray dpcrtlmm_int__defaultArray
#endif /*!DPCRTLMM_NONULL_BLOCKDESCARRAY*/
#define _libStarted dpcrtlmm_int__libStarted
#define _UserTrapCallback dpcrtlmm_int__UserTrapCallback
#define _userTrapCallbackIsHook dpcrtlmm_int__userTrapCallbackIsHook
#define _debugHookMatrix dpcrtlmm_int__debugHookMatrix
#define _ResolveArrayPtr dpcrtlmm_int__ResolveArrayPtr
#define _blockCount dpcrtlmm_int__blockCount
#define _blockCountPeak dpcrtlmm_int__blockCountPeak
#define _allocCharge dpcrtlmm_int__allocCharge
#define _allocPeak dpcrtlmm_int__allocPeak
/*-------------------------------------------------------------------------*/
#endif /*!INC_DPCRTLMM_INTDATA_H*/
